<h2>{$_LANG.page_set_up_for}{$product}</h2>

<form id="enroll-form" method="post" action="clientarea.php?action=productdetails">
    <div class="form-group">
    <h4 class="text-muted">
        <span style="margin-right: 10px;">{$limits_word}</span>
        {if $configoptionsupgrade}
            <a class="btn btn-default btn-sm" href="/upgrade.php?type=configoptions&id={$serviceid}">{$_LANG.btn_append_san_text}</a>
        {/if}
    </h4>
    </div>
    <div class="form-group" id="domainsGroup">
        <label for="domainInput">
            {$_LANG.field_domains}
            {if $_LANG.locale == 'zh_CN'}
                <i class="glyphicon glyphicon-info-sign" data-container="body" data-toggle="popover" data-placement="right" data-trigger="hover" data-title="证书会包含 <code>www.</code> + 主域名吗？" data-content="根据厂家默认规则，若您申请 <code>www.</code> 或主域名且只有一条，厂家会自动补全 <code>www.</code> + 主域名<b class='text-success'>不额外收费</b>。<br/><br/>若申请多域名（不同子域名或不同主域名）<b>不会赠送</b> <code>www.</code> + 主域名，若有需要您可另行购买。"></i>
            {else}
                <i class="glyphicon glyphicon-info-sign" data-container="body" data-toggle="popover" data-placement="right" data-trigger="hover" data-title="<b>Does it contains <code>www.</code>+topdomain?</b>" data-content="Accordance to default rules of certificate provider, if you are enrolling <code>www.</code> or topdomain and only one, they will fulfill <code>www.</code>+topdomain <b class='text-success'>for free</b>.<br/><br/>Otherwise if you are applying multi-subdomain or multi-topdomain, they <b>won't</b> fulfill. But you can purchase during cert validity if you need."></i>
            {/if}
        </label>
        <textarea class="form-control" rows="8" tabindex="1" name="domains" id="domainInput" style="font-family: monospace;" placeholder="{$_LANG.field_placeholder_domains}">{implode(PHP_EOL, $domains)}</textarea>
        <span id="domainsTip" class="help-block"></span>
    </div>
    <div class="form-group">
        <label for="exampleInputPassword1">{$_LANG.field_csr_type}</label>
        <div class="radio">
            <label class="d-block">
                <input type="radio" name="csrType" class="csr-type" value="auto" checked>
                {$_LANG.field_option_csr_generate_cloud} (<b>{$_LANG.recommended}</b>)
                <br>
                <small class="text-success">
                {$_LANG.field_option_csr_generate_cloud_tips}
                </small>
            </label>
        </div>
        <div class="radio">
            <label class="d-block">
                <input type="radio" name="csrType" class="csr-type" value="custom">
                {$_LANG.field_option_csr_upload_my_own}
                <br>
                <small class="text-warning">
                {$_LANG.field_option_csr_upload_my_own_tips}
                </small>
            </label>
        </div>
    </div>
    <div class="form-group hide" id="csrGroup">
        <label for="customCSR">{$_LANG.field_csr}</label>
        <textarea class="form-control" rows="7" tabindex="2" name="csr" id="customCSR" placeholder="-----BEGIN CERTIFICATE REQUEST-----
MIIBDDCBsgIBADAxMQswCQYDVQQGEwJDTjEKMAgGA1UECBMBYjEKMAgGA1UEBxMB
YzEKMAgGA1UEAxMBYTBZMBMGByqGSM49Ag.....
-----END CERTIFICATE REQUEST-----" style="font-family: monospace;"></textarea>
        <span id="csrTip" class="help-block"></span>
    </div>

    <input type="hidden" name="id" value="{$serviceid}" />
    <input type="hidden" name="customAction" value="{$op}" />
    <button type="submit" id="btn-submit" class="btn btn-primary" style="margin-right: 10px;" tabindex="3">{$_LANG.btn_submit}</button>

    <a class="btn btn-default" href="clientarea.php?action=productdetails&id={$serviceid}" tabindex="-1">
        <i class="fa fa-arrow-circle-left"></i> {$_LANG.btn_back_to_overview}
    </a>
</form>

<script>
$(document).ready(function () {
    var isCustomCSR = function() {
        return $('#enroll-form').serializeArray().filter(function (item) { return item['name'] === 'csrType'; })[0].value === 'custom';
    }

    var validDomains = function () {
        var domainsInput = $('form textarea[name="domains"]');
        var regex = {$regex|unescape:'htmlall'};
        var errorDomains = [];
        var required = [];

        if (!domainsInput.val().trim()) {
            required.push(domainsInput);
            errorDomains.push('This field is Required!');
        }


        var domains = domainsInput.val().split(/[\r\n]+/g).filter(function (i) {
            return i.trim();
        });
        for (var i = 0; i < domains.length; i++) {
            var domain = domains[i];
            if (domain.substr(0, 1) == ' ') {
                errorDomains.push(domain + ' starts with a space " ", not allowed');
            } else if (domain.substr(domain.length - 1, 1) == ' ') {
                errorDomains.push(domain + ' ends with a space " ", not allowed');
            } else if (parseInt(domain.replace(/\./g, '')).toString() === domain.replace(/\./g, '') && (domain.substr(0, 6) === '127.0.' || domain.substr(0, 5) === '10.0.' || domain.substr(0, 8) === '192.168.')) {
                errorDomains.push(domain + ' is a intranet iPAddress, not allowed');
            } else if (!regex.test(domain)) {
                errorDomains.push(domain + ' is not a valid domainName / iPAddress');
            }
        }

        if (errorDomains.length > 0) {
            $('#domainsGroup').addClass('has-error');
            $('#domainsTip').html(errorDomains.join("<br/>"));
        } else {
            $('#domainsGroup').removeClass('has-error');
            $('#domainsTip').html('');
        }

        if (errorDomains.length > 0) {
            return false;
        }
        if (required.length) {
            setTimeout(function () {
                required[0].focus();
            }, 100);
            return false;
        }

        return true;
    }

    var validCsr = function () {
        var csrInput = $('form textarea[name="csr"]');
        var errorCsr = [];
        var required = [];

        if (isCustomCSR()) {
            if (!csrInput.val().trim()) {
                required.push(csrInput);
                errorCsr.push('This field is Required!');
            } else {
                var err = null;
                try {
                    var b64 = atob(csrInput.val().trim().replace({$regex_csr|unescape:'htmlall'}, ''));
                } catch (e) {
                    err = e;
                }
                if (
                    csrInput.val().trim().substr(0, 35) != '-----BEGIN CERTIFICATE REQUEST-----'
                    ||
                    csrInput.val().trim().substr(csrInput.val().length - 34, 33) != '-----END CERTIFICATE REQUEST-----'
                    ||
                    err
                ) {
                    required.push(csrInput);
                    errorCsr.push('The CSR is invalid!');
                }
            }
        }

        if (errorCsr.length > 0) {
            $('#csrGroup').addClass('has-error');
            $('#csrTip').html(errorCsr.join("<br/>"));
        } else {
            $('#csrGroup').removeClass('has-error');
            $('#csrTip').html('');
        }
        if (errorCsr.length > 0) {
            return false;
        }
        if (required.length) {
            setTimeout(function () {
                required[0].focus();
            }, 100);
            return false;
        }
        return true;
    };

    $('.csr-type').on('change', function () {
        if (isCustomCSR()) {
            $('#csrGroup').removeClass('hide');
        } else {
            $('#csrGroup').addClass('hide');
        }
    });

    $('#enroll-form').on('submit', function (evt) {
        $('#btn-submit').attr('disabled', true);
        var csrValid = validCsr();
        var domainsValid = validDomains();

        var valid = csrValid && domainsValid;
        if (!valid) {
            $('#btn-submit').removeAttr('disabled');
            return false;
        }
        
        $.ajax({
            url: $(evt.target).attr('action'),
            type: $(evt.target).attr('method'),
            data: $(evt.target).serialize(),
            dataType: 'json',
            success: function (json) {
                if (!json.success) {
                    $.ajax({
                        url: '/modules/servers/ssl/static/js/bootbox.js',
                        dataType: 'script',
                        cache: true,
                        success: function () {
                            bootbox.alert({
                                title: 'Error',
                                message: json.message,
                                size: 'middle'
                            });
                        }
                    });
                    $('#btn-submit').removeAttr('disabled');
                    return;
                }

                location.href = json.data.refresh_url;
            }
        });

        return false;
    });

    $('form textarea[name="domains"]').on('keyup', validDomains);
    $('form textarea[name="csr"]').on('keyup', validCsr);
    setTimeout(function () {
        $('.csr-type').trigger('change');    
    }, 1000);
    
});
</script>