<?php

namespace Utopia\Domains;

use Utopia\Domains\Registrar\Adapter as RegistrarAdapter;

class Registrar
{
    protected $adapter;

    public function __construct($adapter)
    {
        $this->adapter = $adapter;
    }

    public function available($domain)
    {
        return $this->adapter->available($domain);
    }

    public function purchase($domain, $contacts, $nameservers = [])
    {
        return $this->adapter->purchase($domain, $contacts, $nameservers);
    }

    public function suggest($query, $tlds = [], $minLength = 1, $maxLength = 100)
    {
        return $this->adapter->suggest($query, $tlds, $minLength, $maxLength);
    }

    public function tlds()
    {
        return $this->adapter->tlds();
    }

    public function getDomain($domain)
    {
        return $this->adapter->getDomain($domain);
    }

    public function renew($domain, $years)
    {
        return $this->adapter->renew($domain, $years);
    }

    public function transfer($domain, $contacts, $nameservers = [])
    {
        return $this->adapter->transfer($domain, $contacts, $nameservers);
    }
}
