<?php

namespace Utopia\Domains\Registrar;

use Utopia\Domains\Adapter as DomainsAdapter;

abstract class Adapter extends DomainsAdapter
{
    /**
     * @param  string  $domain
     * @return bool
     */
    abstract public function available($domain);

    /**
     * @param  string  $domain
     * @param  Utopia\Domains\Contact[]  $contacts
     * @param  array  $nameservers
     * @return array
     */
    abstract public function purchase($domain, $contacts, $nameservers = []);

    /**
     * @param  array  $query
     * @param  array  $tlds
     * @param  int  $minLength
     * @param  int  $maxLength
     * @return array
     */
    abstract public function suggest($query, $tlds = [], $minLength = 1, $maxLength = 100);

    /**
     * @return array
     */
    abstract public function tlds();

    /**
     * @param  string  $domain
     * @return array
     */
    abstract public function getDomain($domain);

    /**
     * @param  string  $domain
     * @param  int  $years
     * @return array
     */
    abstract public function renew($domain, $years);

    /**
     * @param  string  $domain
     * @param  Utopia\Domains\Contact[]  $contacts
     * @param  array  $nameservers
     * @return array
     */
    abstract public function transfer($domain, $contacts, $nameservers = []);
}
